#include "spawn.h"
#include "time.h"
#include "stdlib.h"

#include "..\algorithms.h"

#include "..\dllcore.cpp"
#include "..\datatypes.cpp"
#include "..\algorithms.cpp"
#include "..\player.cpp"
#include "..\commtypes.cpp"

#define UNASSIGNED 0xffff


//////// Bot list ////////

_linkedlist <botInfo> botlist;

botInfo *findBot(CALL_HANDLE handle)
{
	_listnode <botInfo> *parse = botlist.head;

	while (parse)
	{
		botInfo *item = parse->item;

		if (item->validate(handle))
			return item;

		parse = parse->next;
	}

	return 0;
}


//////// DLL "import" ////////

void botInfo::tell(BotEvent &event)
{
	if (callback && handle)
	{
		event.handle = handle;
		callback(event);
	}
}



void botInfo::Play(Player *p)
{
	// get players deck
	int numdeck = GetPlayerDeck(p);

	if (hand[numdeck][0].isplaying == false)
	{

		// initialize deck
		InitializeDeck(p);

		// players deck now in play
		hand[numdeck][0].isplaying = true;



		// Draw Card 1
		srand(time(NULL));
		rand();
		int tempcard = (int) (51 * ((float)rand()/RAND_MAX));

		while (deck[numdeck][tempcard].used == true)
		{
			tempcard = (int) (51 * ((float)rand()/RAND_MAX));
		}

		hand[numdeck][0].card[hand[numdeck][0].numcards] = tempcard;
		hand[numdeck][0].numcards++;
		hand[numdeck][0].sum += deck[numdeck][tempcard].value;

		deck[numdeck][tempcard].used = true;

		// if ace, increase acecount
		if (tempcard > 47)
		{
			hand[numdeck][0].acecount++;
		}

		// print players first card
		String s = "Your hand: ";
		s += deck[numdeck][tempcard].name;
		s += ", ";



		// Card 2
		tempcard = (int) (51 * ((float)rand()/RAND_MAX));

		while (deck[numdeck][tempcard].used == true)
		{
			tempcard = (int) (51 * ((float)rand()/RAND_MAX));
		}

		hand[numdeck][0].card[hand[numdeck][0].numcards] = tempcard;
		hand[numdeck][0].numcards++;
		hand[numdeck][0].sum += deck[numdeck][tempcard].value;

		deck[numdeck][tempcard].used = true;

		// if ace increment acecount
		if (tempcard > 47)
		{
			hand[numdeck][0].acecount++;
		}

		// print second card
		s += deck[numdeck][tempcard].name;



		// Computer Card 1
		tempcard = (int) (51 * ((float)rand()/RAND_MAX));

		while (deck[numdeck][tempcard].used == true)
		{
			tempcard = (int) (51 * ((float)rand()/RAND_MAX));
		}

		hand[numdeck][1].card[hand[numdeck][1].numcards] = tempcard;
		hand[numdeck][1].numcards++;
		hand[numdeck][1].sum += deck[numdeck][tempcard].value;

		deck[numdeck][tempcard].used = true;

		if (tempcard > 47)
		{
			hand[numdeck][1].acecount++;
		}

		s += ".  Dealer's hand: ";
		s += deck[numdeck][tempcard].name;
		s += ", ";


		// Computer Card 2
		tempcard = (int) (51 * ((float)rand()/RAND_MAX));

		while (deck[numdeck][tempcard].used == true)
		{
			tempcard = (int) (51 * ((float)rand()/RAND_MAX));
		}

		hand[numdeck][1].card[hand[numdeck][1].numcards] = tempcard;
		hand[numdeck][1].numcards++;
		hand[numdeck][1].sum += deck[numdeck][tempcard].value;

		deck[numdeck][tempcard].used = true;

		if (tempcard > 47)
		{
			hand[numdeck][1].acecount++;
		}

		// push on blackjack
		if ((hand[numdeck][0].sum == 21) && (hand[numdeck][1].sum == 21))
		{
			s += deck[numdeck][tempcard].name;
			s += ".";
			sendPrivate(p,s);

			String t= "Tie game on double Blackjack. Your Account: $";
			t += hand[numdeck][0].account;
			sendPrivate(p,t);

			hand[numdeck][0].isplaying = false;
		}

		// Dealer blackjack automatic win
		else if (hand[numdeck][1].sum == 21)
		{
			s += deck[numdeck][tempcard].name;
			s += ".";
			sendPrivate(p,s);

			hand[numdeck][0].account -= hand[numdeck][0].bet;

			String t= "Dealer wins with a Blackjack. Your Account: $";
			t += hand[numdeck][0].account;
			sendPrivate(p,t);

			hand[numdeck][0].isplaying = false;
		}

		//  No Dealer blackjack, player blackjack
		else if (hand[numdeck][0].sum == 21)
		{
			s += deck[numdeck][tempcard].name;
			s += ".";
			sendPrivate(p,s);

			hand[numdeck][0].account += (hand[numdeck][0].bet * 3)/2;

			String t = "You win with a Blackjack. Account: $";
			t += hand[numdeck][0].account;
			sendPrivate(p,t);
			hand[numdeck][0].isplaying = false;
		}

		// no automatic win so print hit or stand
		else
		{
			s += "(hidden).  !Hit or !Stand?";
			sendPrivate(p,s);

			if ((hand[numdeck][0].bet * 2) < hand[numdeck][0].account)
			{
				hand[numdeck][0].doubledown = true;
			}
		}
	}
	else
	{
		// print player hand
		int tempnumcards=0;

		String s = "Your hand: ";
		while (tempnumcards < hand[numdeck][0].numcards)
		{
			s += deck[numdeck][hand[numdeck][0].card[tempnumcards]].name;
			if (tempnumcards < hand[numdeck][0].numcards-1)
				s += ", ";
			tempnumcards++;
		}

		// print computer hand
		s += ".  Dealer hand: ";

		tempnumcards = 0;

		while (tempnumcards < hand[numdeck][1].numcards)
		{
			s += deck[numdeck][hand[numdeck][1].card[tempnumcards]].name;
			if (tempnumcards < hand[numdeck][1].numcards-1)
				s += ", ";
			tempnumcards++;
		}

		sendPrivate(p,s);

		sendPrivate(p,"You are already playing a hand, type !hit or !stand to continue play.");
	}
}

void botInfo::Hit(Player *p)
{

	int numdeck = GetPlayerDeck(p);

	if (hand[numdeck][0].isplaying == true)
	{
		hand[numdeck][0].doubledown = false;

		srand(time(NULL));
		rand();
		int tempcard = (int) (51 * ((float)rand()/RAND_MAX));

		while (deck[numdeck][tempcard].used == true)
		{
			tempcard = (int) (51 * ((float)rand()/RAND_MAX));
		}

		hand[numdeck][0].card[hand[numdeck][0].numcards] = tempcard;
		hand[numdeck][0].numcards++;
		hand[numdeck][0].sum += deck[numdeck][tempcard].value;

		if (tempcard > 47)
		{
			hand[numdeck][0].acecount++;
		}

		deck[numdeck][tempcard].used = true;

		// print player hand
		int tempnumcards=0;

		String s = "Your hand: ";
		while (tempnumcards < hand[numdeck][0].numcards)
		{
			s += deck[numdeck][hand[numdeck][0].card[tempnumcards]].name;
			if (tempnumcards < hand[numdeck][0].numcards-1)
				s += ", ";
			tempnumcards++;
		}

		// print computer hand
		s += ".  Dealer's hand: ";

		// card 1
		s += deck[numdeck][hand[numdeck][1].card[0]].name;
		s += ", ";

		// player has 21 points, goto stand
		if (hand[numdeck][0].sum == 21)
		{
			Stand(p);
		}

		// player has more than 21 points
		else if (hand[numdeck][0].sum > 21)
		{
			// if player has an ace automatically convert it to 1
			if (hand[numdeck][0].acecount > 0)
			{
				hand[numdeck][0].acecount--;
				hand[numdeck][0].sum -= 10;

				s += " (hidden).  !Hit or !Stand?";
				sendPrivate(p,s);
			}
			// otherwise player loses
			else
			{
				// card 2
				s += deck[numdeck][hand[numdeck][1].card[1]].name;
				sendPrivate(p,s);

				hand[numdeck][0].account -= hand[numdeck][0].bet;

				String t;
				t += "You lose with a ";
				t += hand[numdeck][0].sum;
				t += " point hand. Dealer had ";
				t += hand[numdeck][1].sum;
				t += ". Account: $";
				t += hand[numdeck][0].account;
				sendPrivate(p,t);

				

				hand[numdeck][0].isplaying = false;
			}
		}
		// keep going less than 21 pts
		else
		{
			s += " (hidden).  !Hit or !Stand?";
			sendPrivate(p,s);
		}

	}
	else
	{
		sendPrivate(p,"You must !play #bet before you may hit.");
	}
}
void botInfo::Stand(Player *p)
{
	int numdeck = GetPlayerDeck(p);

	if (hand[numdeck][0].isplaying == true)
	{
		hand[numdeck][0].isplaying = false;

		// convert ace to 1 point if over 21 points (dealt two aces)
		if ((hand[numdeck][1].acecount > 0) && (hand[numdeck][1].sum > 21))
			{
				hand[numdeck][1].acecount--;
				hand[numdeck][1].sum -= 10;
			}

		// computer hit while under 16
		while (hand[numdeck][1].sum <= 16)
		{
			srand(time(NULL));
			rand();
			int tempcard = (int) (51 * ((float)rand()/RAND_MAX));

			while (deck[numdeck][tempcard].used == true)
			{
				tempcard = (int) (51 * ((float)rand()/RAND_MAX));
			}

			hand[numdeck][1].card[hand[numdeck][1].numcards] = tempcard;
			hand[numdeck][1].numcards++;
			hand[numdeck][1].sum += deck[numdeck][tempcard].value;

			deck[numdeck][tempcard].used = true;

			// convert an ace to 1 pt if over 21 points
			if ((hand[numdeck][1].acecount > 0) && (hand[numdeck][1].sum > 21))
			{
				hand[numdeck][1].acecount--;
				hand[numdeck][1].sum -= 10;
			}
		}

		// print player hand
		int tempnumcards=0;

		String s = "Your hand: ";
		while (tempnumcards < hand[numdeck][0].numcards)
		{
			s += deck[numdeck][hand[numdeck][0].card[tempnumcards]].name;
			if (tempnumcards < hand[numdeck][0].numcards-1)
				s += ", ";
			tempnumcards++;
		}

		// print computer hand
		s += ".  Dealer hand: ";

		tempnumcards = 0;

		while (tempnumcards < hand[numdeck][1].numcards)
		{
			s += deck[numdeck][hand[numdeck][1].card[tempnumcards]].name;
			if (tempnumcards < hand[numdeck][1].numcards-1)
				s += ", ";
			tempnumcards++;
		}

		sendPrivate(p,s);


		// dealer over 21 lose
		if (hand[numdeck][1].sum > 21)
		{
			hand[numdeck][0].account += (hand[numdeck][0].bet * 3) / 2;

			String t="You win with a ";
			t += hand[numdeck][0].sum;
			t += " point hand. Dealer loses with ";
			t += hand[numdeck][1].sum;
			t += ". Account: $";
			t += hand[numdeck][0].account;
			sendPrivate(p,t);
		}

		// compare two
		// player wins
		else if (hand[numdeck][0].sum > hand[numdeck][1].sum)
		{
			hand[numdeck][0].account += (hand[numdeck][0].bet * 3) / 2;

			String t="You win with a ";
			t += hand[numdeck][0].sum;
			t += " point hand. Dealer had ";
			t += hand[numdeck][1].sum;
			t += ". Account: $";
			t += hand[numdeck][0].account;
			sendPrivate(p,t);
		}
		// dealer wins
		else if (hand[numdeck][0].sum < hand[numdeck][1].sum)
		{
			hand[numdeck][0].account -= hand[numdeck][0].bet;

			String t="You lose with ";
			t += hand[numdeck][0].sum;
			t +=". Dealer wins with a ";
			t += hand[numdeck][1].sum;
			t += " point hand. Account: $";
			t += hand[numdeck][0].account;
			sendPrivate(p,t);
		}
		// tie game, push 
		else
		{
			String t= "Tie game ";
			t += hand[numdeck][0].sum;
			t += " to ";
			t += hand[numdeck][1].sum;
			t +=". Your Account: $";
			t += hand[numdeck][0].account;
			sendPrivate(p,t);

			hand[numdeck][0].isplaying = false;
		}

	}
	else
	{
		sendPrivate(p,"You must !play #bet before you may stand.");
	}
}

void botInfo::DoubleDown(Player *p)
{
	int numdeck = GetPlayerDeck(p);

	if (hand[numdeck][0].isplaying == true)
	{
		if ((hand[numdeck][0].bet * 2) > hand[numdeck][0].account)
		{
			sendPrivate(p,"You do not have enough money in your account to double down.");
		}

		if (hand[numdeck][0].doubledown == true)
		{
			hand[numdeck][0].bet += hand[numdeck][0].bet;

			srand(time(NULL));
			rand();
			int tempcard = (int) (51 * ((float)rand()/RAND_MAX));

			while (deck[numdeck][tempcard].used == true)
			{
				tempcard = (int) (51 * ((float)rand()/RAND_MAX));
			}

			hand[numdeck][0].card[hand[numdeck][0].numcards] = tempcard;
			hand[numdeck][0].numcards++;
			hand[numdeck][0].sum += deck[numdeck][tempcard].value;

			// ace add to acecount
			if (tempcard > 47)
			{
				hand[numdeck][0].acecount++;
			}

			deck[numdeck][tempcard].used = true;

			// player has over 21
			if (hand[numdeck][0].sum > 21)
			{
				// if player has an ace automatically convert it to 1
				if (hand[numdeck][0].acecount > 0)
				{
					hand[numdeck][0].acecount--;
					hand[numdeck][0].sum -= 10;

					Stand(p);
				}
				// otherwise player loses
				else
				{
					hand[numdeck][0].account -= hand[numdeck][0].bet;

					// print player hand
					int tempnumcards=0;

					String s = "Your hand: ";
					while (tempnumcards < hand[numdeck][0].numcards)
					{
						s += deck[numdeck][hand[numdeck][0].card[tempnumcards]].name;
						if (tempnumcards < hand[numdeck][0].numcards-1)
							s += ", ";
						tempnumcards++;
					}

					// print computer hand
					s += ".  Dealer hand: ";

					tempnumcards = 0;

					while (tempnumcards < hand[numdeck][1].numcards)
					{
						s += deck[numdeck][hand[numdeck][1].card[tempnumcards]].name;
						if (tempnumcards < hand[numdeck][1].numcards-1)
							s += ", ";
						tempnumcards++;
					}

					sendPrivate(p,s);

					String t;
					t += "You lose with a ";
					t += hand[numdeck][0].sum;
					t += " point hand. Dealer had ";
					t += hand[numdeck][1].sum;
					t += ". Account: $";
					t += hand[numdeck][0].account;
					sendPrivate(p,t);

					hand[numdeck][0].isplaying = false;
				}
			}
			else
			{
				Stand(p);
			}
			
		}
		else
		{
			sendPrivate(p,"You may only double down with two cards in your hand.");
		}
	}
	else
	{
		sendPrivate(p,"You must !play #bet before you may doubledown.");
	}
}

int botInfo::GetPlayerDeck(Player *p)
{
	int temphand = 19;

	while (temphand >=0)
	{
		if (strcmp(p->name,bj[temphand])==0)
		{
			return temphand;
		}
		temphand--;
	}
	sendPrivate(p,"Welcome to Blackjack. You have $100 in your account. Default bet is $5. Commands: !play #bet (ie. play 20) !hit !stand !doubledown !account !reset");
	strncpy(bj[decknumber], p->name, 20);
	decknumber++;
	return (decknumber-1); //not found

}


void botInfo::InitializeDeck(Player *p)
{
	// initialize deck data
	// 2-10 = 0-35 jack-ace = 36-51
	
	int numdeck = GetPlayerDeck(p);

	int temp=51;

	// set cards in deck to unused
	while (temp>=0)
	{
		deck[numdeck][temp].used = false;
		temp--;
	}

	// initialize hand data
	hand[numdeck][0].numcards = 0;
	hand[numdeck][0].acecount = 0;
	hand[numdeck][0].sum = 0;
	hand[numdeck][0].doubledown = false;

	hand[numdeck][1].numcards = 0;
	hand[numdeck][1].acecount = 0;
	hand[numdeck][1].sum = 0;
	hand[numdeck][1].doubledown = false;

}

void botInfo::gotEvent(BotEvent &event)
{
	if (CONNECTION_DENIED) return;

	switch (event.code)
	{
//////// Periodic ////////
	case EVENT_Tick:
		{
			for (int i = 0; i < 4; ++i)
				--countdown[i];
		}
		break;
//////// Arena ////////
	case EVENT_ArenaEnter:
		{
			arena = (char*)event.p[0];
			me = (Player*)event.p[1];	// if(me) {/*we are in the arena*/}
			bool biller_online = *(bool*)&event.p[2];

			int temp = 98;
			while (temp >=0)
			{
				strncpy(bj[decknumber], me->name, 20);
				temp--;
			}

			int numdeck = 98;

			while (numdeck>=0)
			{
				temp=51;

				while (temp>=0)
				{
					if (temp<36)
					{
						deck[numdeck][temp].value = (temp / 4) + 2;
					}
					if ((temp>=36) && (temp<48))
					{
						deck[numdeck][temp].value=10;
					}
					if (temp>=48)
					{
						deck[numdeck][temp].value=11;
					}
					temp--;
				}

				// initialize hand data

				hand[numdeck][0].account = 100;
				hand[numdeck][0].numcards = 0;
				hand[numdeck][0].acecount = 0;
				hand[numdeck][0].sum = 0;
				hand[numdeck][0].isplaying = false;
				hand[numdeck][0].doubledown = false;

				hand[numdeck][1].numcards = 0;
				hand[numdeck][1].acecount = 0;
				hand[numdeck][1].sum = 0;
				hand[numdeck][1].isplaying = false;
				hand[numdeck][1].doubledown = false;


				strncpy(deck[numdeck][0].name ,"Two",6);
				strncpy(deck[numdeck][1].name ,"Two",6);
				strncpy(deck[numdeck][2].name ,"Two",6);
				strncpy(deck[numdeck][3].name ,"Two",6);

				strncpy(deck[numdeck][4].name ,"Three",6);
				strncpy(deck[numdeck][5].name ,"Three",6);
				strncpy(deck[numdeck][6].name , "Three",6);
				strncpy(deck[numdeck][7].name , "Three",6);

				strncpy(deck[numdeck][8].name , "Four",6);
				strncpy(deck[numdeck][9].name , "Four",6);
				strncpy(deck[numdeck][10].name , "Four",6);
				strncpy(deck[numdeck][11].name , "Four",6);

				strncpy(deck[numdeck][12].name , "Five",6);
				strncpy(deck[numdeck][13].name , "Five",6);
				strncpy(deck[numdeck][14].name , "Five",6);
				strncpy(deck[numdeck][15].name , "Five",6);

				strncpy(deck[numdeck][16].name , "Six",6);
				strncpy(deck[numdeck][17].name , "Six",6);
				strncpy(deck[numdeck][18].name , "Six",6);
				strncpy(deck[numdeck][19].name , "Six",6);

				strncpy(deck[numdeck][20].name , "Seven",6);
				strncpy(deck[numdeck][21].name , "Seven",6);
				strncpy(deck[numdeck][22].name , "Seven",6);
				strncpy(deck[numdeck][23].name , "Seven",6);

				strncpy(deck[numdeck][24].name , "Eight",6);
				strncpy(deck[numdeck][25].name , "Eight",6);
				strncpy(deck[numdeck][26].name , "Eight",6);
				strncpy(deck[numdeck][27].name , "Eight",6);

				strncpy(deck[numdeck][28].name , "Nine",6);
				strncpy(deck[numdeck][29].name , "Nine",6);
				strncpy(deck[numdeck][30].name , "Nine",6);
				strncpy(deck[numdeck][31].name , "Nine",6);

				strncpy(deck[numdeck][32].name , "Ten",6);
				strncpy(deck[numdeck][33].name , "Ten",6);
				strncpy(deck[numdeck][34].name , "Ten",6);
				strncpy(deck[numdeck][35].name , "Ten",6);

				strncpy(deck[numdeck][36].name , "Jack",6);
				strncpy(deck[numdeck][37].name , "Jack",6);
				strncpy(deck[numdeck][38].name , "Jack",6);
				strncpy(deck[numdeck][39].name , "Jack",6);

				strncpy(deck[numdeck][40].name , "Queen",6);
				strncpy(deck[numdeck][41].name , "Queen",6);
				strncpy(deck[numdeck][42].name , "Queen",6);
				strncpy(deck[numdeck][43].name , "Queen",6);

				strncpy(deck[numdeck][44].name , "King",6);
				strncpy(deck[numdeck][45].name , "King",6);
				strncpy(deck[numdeck][46].name , "King",6);
				strncpy(deck[numdeck][47].name , "King",6);

				strncpy(deck[numdeck][48].name , "Ace",6);
				strncpy(deck[numdeck][49].name , "Ace",6);
				strncpy(deck[numdeck][50].name , "Ace",6);
				strncpy(deck[numdeck][51].name , "Ace",6);

				numdeck--;
			}
		}
		break;
	case EVENT_ArenaSettings:
		{
			settings = (arenaSettings*)event.p[0];
		}
		break;
	case EVENT_ArenaLeave:
		{
			me = 0;
			killTags();
		}
		break;
	case EVENT_ArenaListEntry:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
	case EVENT_ArenaListEnd:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
//////// Flag ////////
	case EVENT_FlagGrab:
		{
			Player *p = (Player*)event.p[0];
			Flag *f = (Flag*)event.p[1];
		}
		break;
	case EVENT_FlagDrop:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_FlagMove:
		{
			Flag *f = (Flag*)event.p[0];
		}
		break;
	case EVENT_FlagVictory:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
	case EVENT_FlagReward:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
//////// Timed ////////
	case EVENT_TimedGameOver:
		{
			Player *p[5];
			for (int i = 0; i < 5; i++)
				p[i] = (Player*)event.p[i];
		}
		break;
//////// Soccer ////////
	case EVENT_SoccerGoal:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
	case EVENT_BallMove:
		{
			PBall *ball = (PBall*)event.p[0];
		}
		break;
//////// File ////////
	case EVENT_File:
		{
			char *name = (char*)event.p[0];
		}
		break;
//////// Player ////////
	case EVENT_PlayerEntering:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerMove:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerWeapon:
		{
			Player *p = (Player*)event.p[0];
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[1];
		}
		break;
	case EVENT_PlayerDeath:
		{
			Player *p = (Player*)event.p[0],
				   *k = (Player*)event.p[1];
			Uint16 bounty = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerScore:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerPrize:
		{
			Player *p = (Player*)event.p[0];
			int prize = *(int *)&event.p[1];
		}
		break;
	case EVENT_PlayerShip:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldship = (Uint16)event.p[1];
			Uint16 oldteam = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerSpec:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerTeam:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerLeaving:
		{
			Player *p = (Player*)event.p[0];

			killTags(p);
		}
		break;
//////// Selfish ////////
	case EVENT_SelfShipReset:
		{
		}
		break;
	case EVENT_SelfPrize:
		{
			Uint16 prize = (Uint16)event.p[0];
			Uint16 count = (Uint16)event.p[1];
		}
		break;
	case EVENT_SelfUFO:
		{
		}
		break;
	case EVENT_PositionHook:
		{
		}
		break;
//////// Bricks ////////
	case EVENT_BrickDropped:
		{
			int x1 = *(int*)&event.p[0];
			int y1 = *(int*)&event.p[1];
			int x2 = *(int*)&event.p[2];
			int y2 = *(int*)&event.p[3];
			int team = *(int*)&event.p[4];
		}
		break;
//////// LVZ ////////
	case EVENT_ObjectToggled:
		{
			objectInfo obj;
			obj.n = (Uint16)event.p[0];
		}
		break;
//////// Turret ////////
	case EVENT_CreateTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
	case EVENT_DeleteTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
//////// Chat ////////
	case EVENT_Chat:
		{
			int type  = *(int*)&event.p[0];
			int sound = *(int*)&event.p[1];
			Player *p = (Player*)event.p[2];
			char *msg = (char*)event.p[3];

			switch (type)
			{
			case MSG_Arena:
				{
				}
				break;
			case MSG_PublicMacro:		if (!p) break;
				{
				}
				break;
			case MSG_Public:			if (!p) break;
				{
				}
				break;
			case MSG_Team:				if (!p) break;
				{
				}
				break;
			case MSG_TeamPrivate:		if (!p) break;
				{
				}
				break;
			case MSG_Private:			if (!p) break;
				{
				}
				break;
			case MSG_PlayerWarning:		if (!p) break;
				{
				}
				break;
			case MSG_RemotePrivate:
				{
				}
				break;
			case MSG_ServerError:
				{
				}
				break;
			case MSG_Channel:
				{
				}
				break;
			};
		}
		break;
	case EVENT_LocalCommand:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotCommand(p, c);
		}
		break;
	case EVENT_LocalHelp:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotHelp(p, c);
		}
		break;
	case EVENT_RemoteCommand:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemote(p, c, o);
		}
		break;
	case EVENT_RemoteHelp:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemoteHelp(p, c, o);
		}
		break;
//////// Containment ////////
	case EVENT_Init:
		{
			int major	= HIWORD(*(int*)&event.p[0]);
			int minor	= LOWORD(*(int*)&event.p[0]);
			callback	= (CALL_COMMAND)event.p[1];
			playerlist	= (CALL_PLIST)event.p[2];
			flaglist	= (CALL_FLIST)event.p[3];
			map			= (CALL_MAP)event.p[4];
			bricklist	= (CALL_BLIST)event.p[5];

			if (major > CORE_MAJOR_VERSION)
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin is out of date."));

				CONNECTION_DENIED = true;

				return;
			}
			else if ((major < CORE_MAJOR_VERSION) || (minor < CORE_MINOR_VERSION))
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin requires the latest version of MERVBot."));

				CONNECTION_DENIED = true;

				return;
			}
			else
				tell(makeEcho("DLL plugin connected."));

		}
		break;
	case EVENT_Term:
		{
			tell(makeEcho("DLL plugin disconnected."));
		}
		break;
	};
}


//////// DLL export ////////

_declspec(dllexport) void __stdcall talk(BotEvent &event)
{
	botInfo *bot;

	bot = findBot(event.handle);

	if (!bot)
	{
		bot = new botInfo(event.handle);
		botlist.append(bot);
	}

	if (bot) bot->gotEvent(event);
}


//////// Tag emulation ////////

int botInfo::get_tag(Player *p, int index)
{
	_listnode <PlayerTag> *parse = taglist.head;
	PlayerTag *tag;

	while (parse)
	{
		tag = parse->item;

		if (tag->p == p)
		if (tag->index == index)
			return tag->data;

		parse = parse->next;
	}

	return 0;
}

void botInfo::set_tag(Player *p, int index, int data)
{
	_listnode <PlayerTag> *parse = taglist.head;
	PlayerTag *tag;

	while (parse)
	{
		tag = parse->item;

		if (tag->p == p)
		if (tag->index == index)
		{
			tag->data = data;
			return;
		}

		parse = parse->next;
	}

	tag = new PlayerTag;
	tag->p = p;
	tag->index = index;
	tag->data = data;
	taglist.append(tag);
}

void botInfo::killTags(Player *p)
{
	_listnode <PlayerTag> *parse = taglist.head;
	PlayerTag *tag;

	while (parse)
	{
		tag = parse->item;
		parse = parse->next;

		if (tag->p != p) continue;

		taglist.kill(tag);
	}
}

void botInfo::killTags()
{
	taglist.clear();
}


//////// LVZ Object Toggling ////////

void botInfo::clear_objects()
{
	num_objects = 0;
}

void botInfo::object_target(Player *p)
{
	object_dest = p;
}

void botInfo::toggle_objects()
{
	Player *p = object_dest;

	if (p)	tell(makeToggleObjects(UNASSIGNED, (Uint16 *)object_array, num_objects));
	else	tell(makeToggleObjects(p->ident, (Uint16 *)object_array, num_objects));

	num_objects = 0;
}

void botInfo::queue_enable(int id)
{
	if (num_objects == MAX_OBJECTS)
		toggle_objects();

	object_array[num_objects].id = id;
	object_array[num_objects].disabled = false;
	++num_objects;
}

void botInfo::queue_disable(int id)
{
	if (num_objects == MAX_OBJECTS)
		toggle_objects();

	object_array[num_objects].id = id;
	object_array[num_objects].disabled = true;
	++num_objects;
}


//////// Chatter ////////

void botInfo::sendPrivate(Player *player, BYTE snd, char *msg)
{
	tell(makeSay(MSG_Private, snd, player->ident, msg));
}

void botInfo::sendPrivate(Player *player, char *msg)
{
	tell(makeSay(MSG_Private, 0, player->ident, msg));
}

void botInfo::sendTeam(char *msg)
{
	tell(makeSay(MSG_Team, 0, 0, msg));
}

void botInfo::sendTeam(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Team, snd, 0, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, 0, team, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, BYTE snd, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, snd, team, msg));
}

void botInfo::sendPublic(char *msg)
{
	tell(makeSay(MSG_Public, 0, 0, msg));
}

void botInfo::sendPublic(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Public, snd, 0, msg));
}

void botInfo::sendPublicMacro(char *msg)
{
	tell(makeSay(MSG_PublicMacro, 0, 0, msg));
}

void botInfo::sendPublicMacro(BYTE snd, char *msg)
{
	tell(makeSay(MSG_PublicMacro, snd, 0, msg));
}

void botInfo::sendChannel(char *msg)
{
	tell(makeSay(MSG_Channel, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *msg)
{
	tell(makeSay(MSG_RemotePrivate, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *name, char *msg)
{
	String s;
	s += ":";
	s += name;
	s += ":";
	s += msg;

	sendRemotePrivate(s);
}
